/// <reference types="node" />
import EventEmitter from "events";
import { ListenerRss } from "listener-rss";
import { SqliteTools } from "./sqlite-tools";
/**
 * Permit to manage a ListenerRSS array, data storage and event aggregation
 */
export declare class ListenerRssAggregator extends EventEmitter {
    private listenerMap;
    private looprunning;
    private sqliteDb;
    constructor(args: {
        sqliteDB: SqliteTools;
        configInstantiated: Map<string, ListenerRss>;
    });
    static instantiateAggregator(path: string): Promise<{
        sqliteDB: SqliteTools;
        configInstantiated: Map<string, ListenerRss>;
    }>;
    /**
     * @brief [private don't use it] create a sqlite instance for the specified path and load the data
     */
    private static loadDb;
    /**
     * @brief [private don't use it] load the actual config inside the sqliteTools instance specified
     */
    private static extractConfig;
    getAllConfigs(): Promise<ListenerRss.Config[]>;
    editConfig(callback: (config: ListenerRss.Config[]) => ListenerRss.Config[]): Promise<void>;
    private addNewListener;
    private removeOldListener;
    registerListener(info: ListenerRss.Config): Promise<void>;
    unregisterListener(addr: string): Promise<void>;
    saveOverride(expectedConfig: ListenerRss.Config[]): Promise<void>;
    startAll(): void;
    stopAll(): void;
}
//# sourceMappingURL=listener-rss-aggregator.d.ts.map